diff -u -r linux.clean/drivers/cdrom/cdu31a.c linux.new2/drivers/cdrom/cdu31a.c
--- linux.clean/drivers/cdrom/cdu31a.c	Wed Jul 28 18:24:14 1999
+++ linux.new2/drivers/cdrom/cdu31a.c	Wed Jul 28 19:06:20 1999
@@ -1641,7 +1641,7 @@
  * data access on a CD is done sequentially, this saves a lot of operations.
  */
 static void
-do_cdu31a_request(void)
+do_cdu31a_request(request_queue_t * q)
 {
    int block;
    int nblock;
@@ -3497,7 +3497,7 @@
 
       is_a_cdu31a = strcmp("CD-ROM CDU31A", drive_config.product_id) == 0;
 
-      blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+      blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
       read_ahead[MAJOR_NR] = CDU31A_READAHEAD;
       cdu31a_block_size = 1024; /* 1kB default block size */
       /* use 'mount -o block=2048' */
diff -u -r linux.clean/drivers/cdrom/cm206.c linux.new2/drivers/cdrom/cm206.c
--- linux.clean/drivers/cdrom/cm206.c	Wed Jul 28 18:24:14 1999
+++ linux.new2/drivers/cdrom/cm206.c	Wed Jul 28 19:06:20 1999
@@ -801,7 +801,7 @@
 /* This is not a very smart implementation. We could optimize for 
    consecutive block numbers. I'm not convinced this would really
    bring down the processor load. */
-static void do_cm206_request(void)
+static void do_cm206_request(request_queue_t * q)
 {
   long int i, cd_sec_no;
   int quarter, error; 
@@ -1394,7 +1394,7 @@
     cleanup(3);
     return -EIO;
   }    
-  blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+  blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
   blksize_size[MAJOR_NR] = cm206_blocksizes;
   read_ahead[MAJOR_NR] = 16;	/* reads ahead what? */
   init_bh(CM206_BH, cm206_bh);
diff -u -r linux.clean/drivers/cdrom/gscd.c linux.new2/drivers/cdrom/gscd.c
--- linux.clean/drivers/cdrom/gscd.c	Wed Jul 28 18:24:14 1999
+++ linux.new2/drivers/cdrom/gscd.c	Wed Jul 28 19:06:20 1999
@@ -86,7 +86,8 @@
 
 /* Schnittstellen zum Kern/FS */
 
-static void do_gscd_request       (void);
+static void do_gscd_request       (request_queue_t *);
+static void __do_gscd_request     (void);
 static int  gscd_ioctl            (struct inode *, struct file *, unsigned int, unsigned long);
 static int  gscd_open             (struct inode *, struct file *);
 static int  gscd_release          (struct inode *, struct file *);
@@ -260,7 +261,12 @@
  * I/O request routine called from Linux kernel.
  */
 
-static void do_gscd_request (void)
+static void do_gscd_request (request_queue_t * q)
+{
+  __do_gscd_request();
+}
+
+static void __do_gscd_request (void)
 {
 unsigned int block,dev;
 unsigned int nsect;
@@ -355,7 +361,7 @@
               end_request(1);
 	   }
 	}
-	SET_TIMER(do_gscd_request, 1);
+	SET_TIMER(__do_gscd_request, 1);
 }
 
 
@@ -1060,7 +1066,7 @@
 		return -EIO;
 	}
 
-	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
 	blksize_size[MAJOR_NR] = gscd_blocksizes;
 	read_ahead[MAJOR_NR] = 4;
         
diff -u -r linux.clean/drivers/cdrom/mcd.c linux.new2/drivers/cdrom/mcd.c
--- linux.clean/drivers/cdrom/mcd.c	Wed Jul 28 18:24:15 1999
+++ linux.new2/drivers/cdrom/mcd.c	Wed Jul 28 19:06:20 1999
@@ -648,7 +648,7 @@
 
 
 static void
-do_mcd_request(void)
+do_mcd_request(request_queue_t * q)
 {
 #ifdef TEST2
   printk(" do_mcd_request(%ld+%ld)\n", CURRENT -> sector, CURRENT -> nr_sectors);
@@ -1179,7 +1179,7 @@
 	}
 
 	blksize_size[MAJOR_NR] = mcd_blocksizes;
-	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
 	read_ahead[MAJOR_NR] = 4;
 
 	/* check for card */
diff -u -r linux.clean/drivers/cdrom/mcdx.c linux.new2/drivers/cdrom/mcdx.c
--- linux.clean/drivers/cdrom/mcdx.c	Wed Jul 28 18:24:15 1999
+++ linux.new2/drivers/cdrom/mcdx.c	Wed Jul 28 19:06:21 1999
@@ -208,7 +208,7 @@
 
 /* declared in blk.h */
 int mcdx_init(void);
-void do_mcdx_request(void);
+void do_mcdx_request(request_queue_t * q);
 
 /* already declared in init/main */
 void mcdx_setup(char *, int *);
@@ -521,7 +521,7 @@
 	}
 }
 
-void do_mcdx_request()
+void do_mcdx_request(request_queue_t * q)
 {
     int dev;
     struct s_drive_stuff *stuffp;
@@ -1116,7 +1116,7 @@
 		return 1;
 	}
 
-	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
 	read_ahead[MAJOR_NR] = READ_AHEAD;
 	blksize_size[MAJOR_NR] = mcdx_blocksizes;
 
diff -u -r linux.clean/drivers/cdrom/optcd.c linux.new2/drivers/cdrom/optcd.c
--- linux.clean/drivers/cdrom/optcd.c	Wed Jul 28 18:24:15 1999
+++ linux.new2/drivers/cdrom/optcd.c	Wed Jul 28 19:06:21 1999
@@ -1360,7 +1360,7 @@
 }
 
 
-static void do_optcd_request(void)
+static void do_optcd_request(request_queue_t * q)
 {
 	DEBUG((DEBUG_REQUEST, "do_optcd_request(%ld+%ld)",
 	       CURRENT -> sector, CURRENT -> nr_sectors));
@@ -2067,7 +2067,7 @@
 
 	hardsect_size[MAJOR_NR] = &hsecsize;
 	blksize_size[MAJOR_NR] = &blksize;
-	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
 	read_ahead[MAJOR_NR] = 4;
 	request_region(optcd_port, 4, "optcd");
 
diff -u -r linux.clean/drivers/cdrom/sbpcd.c linux.new2/drivers/cdrom/sbpcd.c
--- linux.clean/drivers/cdrom/sbpcd.c	Wed Jul 28 18:24:15 1999
+++ linux.new2/drivers/cdrom/sbpcd.c	Wed Jul 28 19:06:21 1999
@@ -4794,7 +4794,7 @@
 /*
  *  I/O request routine, called from Linux kernel.
  */
-static void DO_SBPCD_REQUEST(void)
+static void DO_SBPCD_REQUEST(request_queue_t * q)
 {
 	u_int block;
 	u_int nsect;
@@ -5725,7 +5725,7 @@
 		goto init_done;
 #endif MODULE
 	}
-	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
 	read_ahead[MAJOR_NR] = buffers * (CD_FRAMESIZE / 512);
 	
 	request_region(CDo_command,4,major_name);
diff -u -r linux.clean/drivers/cdrom/sjcd.c linux.new2/drivers/cdrom/sjcd.c
--- linux.clean/drivers/cdrom/sjcd.c	Wed Jul 28 18:24:15 1999
+++ linux.new2/drivers/cdrom/sjcd.c	Wed Jul 28 19:06:21 1999
@@ -1272,7 +1272,7 @@
   SJCD_SET_TIMER( sjcd_poll, 1 );
 }
 
-static void do_sjcd_request( void ){
+static void do_sjcd_request( request_queue_t * q ){
 #if defined( SJCD_TRACE )
   printk( "SJCD: do_sjcd_request(%ld+%ld)\n",
 	 CURRENT->sector, CURRENT->nr_sectors );
@@ -1475,7 +1475,7 @@
     return( -EIO );
   }
   
-  blk_dev[ MAJOR_NR ].request_fn = DEVICE_REQUEST;
+  blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
   read_ahead[ MAJOR_NR ] = 4;
   
   if( check_region( sjcd_base, 4 ) ){
diff -u -r linux.clean/drivers/cdrom/sonycd535.c linux.new2/drivers/cdrom/sonycd535.c
--- linux.clean/drivers/cdrom/sonycd535.c	Sat Sep 11 08:08:57 1999
+++ linux.new2/drivers/cdrom/sonycd535.c	Sat Sep 11 08:10:38 1999
@@ -781,7 +781,7 @@
  * data access on a CD is done sequentially, this saves a lot of operations.
  */
 static void
-do_cdu535_request(void)
+do_cdu535_request(request_queue_t * q)
 {
 	unsigned int dev;
 	unsigned int read_size;
@@ -1601,7 +1601,7 @@
 							MAJOR_NR, CDU535_MESSAGE_NAME);
 					return -EIO;
 				}
-				blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+				blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
 				blksize_size[MAJOR_NR] = &sonycd535_block_size;
 				read_ahead[MAJOR_NR] = 8;	/* 8 sector (4kB) read-ahead */
 
diff -u -r linux.clean/drivers/i2o/i2o_block.c linux.new2/drivers/i2o/i2o_block.c
--- linux.clean/drivers/i2o/i2o_block.c	Sun Nov  7 16:35:20 1999
+++ linux.new2/drivers/i2o/i2o_block.c	Sun Nov  7 16:48:09 1999
@@ -118,7 +118,7 @@
 
 static int i2ob_install_device(struct i2o_controller *, struct i2o_device *, int);
 static void i2ob_end_request(struct request *);
-static void i2ob_request(void);
+static void i2ob_request(request_queue_t * q);
 
 /*
  * Dump messages.
@@ -135,7 +135,6 @@
         printk(KERN_INFO "\n");
 }
 
-
 /*
  *	Get a message
  */
@@ -399,7 +398,7 @@
 	 */
 	 
 	atomic_dec(&queue_depth);
-	i2ob_request();
+	i2ob_request(NULL);
 	spin_unlock_irqrestore(&io_request_lock, flags);
 }
 
@@ -453,7 +452,7 @@
  *	we use it.
  */
 
-static void i2ob_request(void)
+static void i2ob_request(request_queue_t * q)
 {
 	struct request *req;
 	struct i2ob_request *ireq;
@@ -527,7 +526,6 @@
 	}
 }
 
-
 /*
  *	SCSI-CAM for ioctl geometry mapping
  *	Duplicated with SCSI - this should be moved into somewhere common
@@ -1086,7 +1084,9 @@
 	blk_size[MAJOR_NR] = i2ob_sizes;
 	max_sectors[MAJOR_NR] = i2ob_max_sectors;
 	
-	blk_dev[MAJOR_NR].request_fn = i2ob_request;
+	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), i2ob_request);
+        blk_queue_headactive(BLK_DEFAULT_QUEUE(MAJOR_NR), 0);
+
 	for (i = 0; i < MAX_I2OB << 4; i++) {
 		i2ob_dev[i].refcnt = 0;
 		i2ob_dev[i].flags = 0;
diff -u -r linux.clean/drivers/scsi/Config.in linux.new2/drivers/scsi/Config.in
--- linux.clean/drivers/scsi/Config.in	Sun Oct 17 15:45:17 1999
+++ linux.new2/drivers/scsi/Config.in	Sun Nov 14 08:26:49 1999
@@ -10,8 +10,12 @@
 
 comment 'Some SCSI devices (e.g. CD jukebox) support multiple LUNs'
 
-bool '  Probe all LUNs on each SCSI device' CONFIG_SCSI_MULTI_LUN
+if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
+  bool 'Enable extra checks in new queueing code' CONFIG_SCSI_DEBUG_QUEUES
+fi
 
+bool '  Probe all LUNs on each SCSI device' CONFIG_SCSI_MULTI_LUN
+  
 bool '  Verbose SCSI error reporting (kernel size +=12K)' CONFIG_SCSI_CONSTANTS
 bool '  SCSI logging facility' CONFIG_SCSI_LOGGING
 
diff -u -r linux.clean/drivers/scsi/Makefile linux.new2/drivers/scsi/Makefile
--- linux.clean/drivers/scsi/Makefile	Sun Oct 17 15:38:26 1999
+++ linux.new2/drivers/scsi/Makefile	Sun Oct 17 15:39:14 1999
@@ -40,8 +40,8 @@
     OX_OBJS  := scsi_syms.o
   endif
   L_OBJS += scsi_n_syms.o hosts.o scsi_ioctl.o constants.o scsicam.o
-  L_OBJS += scsi_error.o scsi_obsolete.o scsi_queue.o
-  L_OBJS += scsi_proc.o
+  L_OBJS += scsi_error.o scsi_obsolete.o scsi_queue.o scsi_lib.o 
+  L_OBJS += scsi_merge.o scsi_proc.o
 else
   ifeq ($(CONFIG_SCSI),m)
     MIX_OBJS += scsi_syms.o
@@ -713,10 +713,11 @@
 	$(CC) $(CFLAGS) -c megaraid.c
 
 scsi_mod.o: $(MIX_OBJS) hosts.o scsi.o scsi_ioctl.o constants.o \
-		scsicam.o scsi_proc.o scsi_error.o scsi_obsolete.o scsi_queue.o
+		scsicam.o scsi_proc.o scsi_error.o scsi_obsolete.o \
+		scsi_queue.o scsi_lib.o scsi_merge.o
 	$(LD) $(LD_RFLAG) -r -o $@ $(MIX_OBJS) hosts.o scsi.o scsi_ioctl.o \
-		constants.o scsicam.o scsi_proc.o               \
-		scsi_error.o scsi_obsolete.o scsi_queue.o \
+		constants.o scsicam.o scsi_proc.o scsi_merge.o     \
+		scsi_error.o scsi_obsolete.o scsi_queue.o scsi_lib.o
 
 sr_mod.o: sr.o sr_ioctl.o sr_vendor.o
 	$(LD) $(LD_RFLAG) -r -o $@ sr.o sr_ioctl.o sr_vendor.o
diff -u -r linux.clean/drivers/scsi/aha1542.c linux.new2/drivers/scsi/aha1542.c
--- linux.clean/drivers/scsi/aha1542.c	Sun Oct 17 12:32:56 1999
+++ linux.new2/drivers/scsi/aha1542.c	Sun Nov 14 08:57:51 1999
@@ -1297,7 +1297,9 @@
      * check for timeout, and if we are doing something like this
      * we are pretty desperate anyways.
      */
+    spin_unlock_irq(&io_request_lock);
     scsi_sleep(4*HZ);
+    spin_lock_irq(&io_request_lock);
 
     WAIT(STATUS(SCpnt->host->io_port), 
 	 STATMASK, INIT|IDLE, STST|DIAGF|INVDCMD|DF|CDF);
@@ -1364,7 +1366,9 @@
      * check for timeout, and if we are doing something like this
      * we are pretty desperate anyways.
      */
+    spin_unlock_irq(&io_request_lock);
     scsi_sleep(4*HZ);
+    spin_lock_irq(&io_request_lock);
 
     WAIT(STATUS(SCpnt->host->io_port), 
 	 STATMASK, INIT|IDLE, STST|DIAGF|INVDCMD|DF|CDF);
diff -u -r linux.clean/drivers/scsi/gdth_proc.c linux.new2/drivers/scsi/gdth_proc.c
--- linux.clean/drivers/scsi/gdth_proc.c	Wed May 12 16:27:37 1999
+++ linux.new2/drivers/scsi/gdth_proc.c	Sun Nov 14 08:58:07 1999
@@ -938,10 +938,8 @@
     scp->request.rq_status = RQ_SCSI_BUSY;
     scp->request.sem = &sem;
     scp->SCp.this_residual = IOCTL_PRI;
-    GDTH_LOCK_SCSI_DOCMD();
     scsi_do_cmd(scp, cmnd, gdtcmd, sizeof(gdth_cmd_str), 
                 gdth_scsi_done, timeout*HZ, 1);
-    GDTH_UNLOCK_SCSI_DOCMD();
     down(&sem);
 }
 
diff -u -r linux.clean/drivers/scsi/hosts.c linux.new2/drivers/scsi/hosts.c
--- linux.clean/drivers/scsi/hosts.c	Sun Oct 17 15:38:27 1999
+++ linux.new2/drivers/scsi/hosts.c	Sun Nov 14 09:07:36 1999
@@ -692,8 +692,6 @@
     atomic_set(&retval->host_active,0);
     retval->host_busy = 0;
     retval->host_failed = 0;
-    retval->block = NULL;
-    retval->wish_block = 0;
     if(j > 0xffff) panic("Too many extra bytes requested\n");
     retval->extra_bytes = j;
     retval->loaded_as_module = scsi_loadable_module_flag;
@@ -719,11 +717,8 @@
     retval->ehandler = NULL;    /* Initial value until the thing starts up. */
     retval->eh_notify   = NULL;    /* Who we notify when we exit. */
 
-    /*
-     * Initialize the fields used for mid-level queueing.
-     */
-    retval->pending_commands = NULL;
-    retval->host_busy = FALSE;
+
+    retval->host_blocked = FALSE;
 
 #ifdef DEBUG
     printk("Register %x %x: %d\n", (int)retval, (int)retval->hostt, j);
@@ -779,6 +774,7 @@
 
             kernel_thread((int (*)(void *))scsi_error_handler, 
                           (void *) shpnt, 0);
+
             /*
              * Now wait for the kernel error thread to initialize itself
              * as it might be needed when we scan the bus.
@@ -869,7 +865,6 @@
     printk ("scsi : %d host%s.\n", next_scsi_host,
 	    (next_scsi_host == 1) ? "" : "s");
     
-    scsi_make_blocked_list();
     
     /* Now attach the high level drivers */
 #ifdef CONFIG_BLK_DEV_SD
diff -u -r linux.clean/drivers/scsi/hosts.h linux.new2/drivers/scsi/hosts.h
--- linux.clean/drivers/scsi/hosts.h	Wed Oct 20 16:36:45 1999
+++ linux.new2/drivers/scsi/hosts.h	Sun Nov 14 09:07:39 1999
@@ -1,6 +1,6 @@
 /*
  *  hosts.h Copyright (C) 1992 Drew Eckhardt
- *          Copyright (C) 1993, 1994, 1995 Eric Youngdale
+ *          Copyright (C) 1993, 1994, 1995, 1998, 1999 Eric Youngdale
  *
  *  mid to low-level SCSI driver interface header
  *      Initial versions: Drew Eckhardt
@@ -8,7 +8,7 @@
  *
  *  <drew@colorado.edu>
  *
- *	 Modified by Eric Youngdale eric@aib.com to
+ *	 Modified by Eric Youngdale eric@andante.org to
  *	 add scatter-gather, multiple outstanding request, and other
  *	 enhancements.
  *
@@ -297,13 +297,7 @@
      */
     struct Scsi_Host      * next;
     Scsi_Device           * host_queue;
-    /*
-     * List of commands that have been rejected because either the host
-     * or the device was busy.  These need to be retried relatively quickly,
-     * but we need to hold onto it for a short period until the host/device
-     * is available.
-     */
-    Scsi_Cmnd             * pending_commands;
+
 
     struct task_struct    * ehandler;  /* Error recovery thread. */
     struct semaphore      * eh_wait;   /* The error recovery thread waits on
@@ -336,13 +330,6 @@
     unsigned int max_lun;
     unsigned int max_channel;
 
-    /*
-     * Pointer to a circularly linked list - this indicates the hosts
-     * that should be locked out of performing I/O while we have an active
-     * command on this host.
-     */
-    struct Scsi_Host * block;
-    unsigned wish_block:1;
 
     /* These parameters should be set by the detect routine */
     unsigned char *base;
@@ -387,9 +374,14 @@
      * Host uses correct SCSI ordering not PC ordering. The bit is
      * set for the minority of drivers whose authors actually read the spec ;)
      */
-
     unsigned reverse_ordering:1;
-    
+
+    /*
+     * Indicates that one or more devices on this host were starved, and
+     * when the device becomes less busy that we need to feed them.
+     */
+    unsigned some_device_starved:1;
+   
     void (*select_queue_depths)(struct Scsi_Host *, Scsi_Device *);
 
     /*
@@ -408,7 +400,6 @@
 
 extern void build_proc_dir_entries(Scsi_Host_Template  *);
 
-
 /*
  *  scsi_init initializes the scsi hosts.
  */
@@ -452,6 +443,7 @@
     void (*finish)(void);	  /* Perform initialization after attachment */
     int (*attach)(Scsi_Device *); /* Attach devices to arrays */
     void (*detach)(Scsi_Device *);
+    int (*init_command)(Scsi_Cmnd *);     /* Used by new queueing code. */
 };
 
 extern struct Scsi_Device_Template sd_template;
